//
//  BleManager.h
//  epuck2-ble-monitor
//
//  Created by Stefano Morgani on 01.05.19.
//  Copyright (c) 2019 GCtronic. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreBluetooth/CoreBluetooth.h>
#import "PeripheralCell.h"
#import "Constants.h"

@interface BleManager : NSObject <CBCentralManagerDelegate, CBPeripheralDelegate> {
    
    NSMutableArray *peripherals;
    CBPeripheral *blePeripheral;
    NSData* bleBuff;
    uint8_t writeTrials;
    BOOL sendingData;
    int rxLength;
    unsigned char rxBytes[MSG_SIZE_RX];
    BOOL withResponseLast;
}

@property (strong, nonatomic) CBCentralManager *BTManager;
@property (nonatomic, retain) CBCharacteristic *txCharacteristic;

+ (id)sharedInstance;
- (BOOL)bleIsOff;
- (void)disconnectPeripheral;
- (void)startScanning;
- (void)stopScanning;
- (NSInteger)peripheralsCount;
- (void)setCurrentPeripheral:(NSInteger)index;
- (NSMutableArray *)getPeripherals;
- (NSString *)getPeripheralName:(NSInteger)index;
- (int)getPeripheralRssi:(NSInteger)index;
- (void)connectToPeripheral;
- (NSString *)getCurrentPeripheralName;
- (void)freeCurrentPeripheral;
- (void) writeString:(NSString *)string withResponse:(BOOL)value;
- (void) writeChar:(unsigned char)cmd withResponse:(BOOL)value;
- (void) writeArray:(unsigned char*)msg withResponse:(BOOL)value;
- (int) getRxLength;
- (void) getRxBytes:(unsigned char*)bytes;
- (void) clearDiscoveredPeripherals;

@end
