//
//  RawSensorsViewController.m
//  epuck2-ble-monitor
//
//  Created by Stefano Morgani on 01.05.19.
//  Copyright (c) 2019 GCtronic. All rights reserved.
//

#import "RawSensorsViewController.h"
#import "Robot.h"

@interface RawSensorsViewController ()

@end

@implementation RawSensorsViewController

@synthesize lblProx0;
@synthesize lblProx1;
@synthesize lblProx2;
@synthesize lblProx3;
@synthesize lblProx4;
@synthesize lblProx5;
@synthesize lblProx6;
@synthesize lblProx7;
@synthesize lblFreq;
@synthesize btnLog;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(sensorsUpdated:) name:@"sensorsUpdatedNotification" object:nil];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (void)sensorsUpdated:(NSNotification*)notification {
    lblFreq.text = [NSString stringWithFormat:@"%d Hz", [[Robot sharedInstance] getRxFrequency]];
    lblProx0.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:0]];
    lblProx1.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:1]];
    lblProx2.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:2]];
    lblProx3.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:3]];
    lblProx4.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:4]];
    lblProx5.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:5]];
    lblProx6.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:6]];
    lblProx7.text = [NSString stringWithFormat:@"%d", [[Robot sharedInstance] getProxValue:7]];
}

- (IBAction)sendForward:(id)sender {
    [[Robot sharedInstance] setMotorLeft:255 andRight:255];
}

- (IBAction)sendLeft:(id)sender {
    [[Robot sharedInstance] setMotorLeft:-256 andRight:255];
}

- (IBAction)sendStop:(id)sender {
    [[Robot sharedInstance] setMotorLeft:0 andRight:0];
}

- (IBAction)sendRight:(id)sender {
    [[Robot sharedInstance] setMotorLeft:255 andRight:-256];
}

- (IBAction)sendBackward:(id)sender {
    [[Robot sharedInstance] setMotorLeft:-256 andRight:-256];
}

- (IBAction)btnLogPressed:(id)sender {
    if([[Robot sharedInstance] isLogEnabled]) {
        [[Robot sharedInstance] stopLog];
        [btnLog setTitle:@"Start log" forState:UIControlStateNormal];
    } else {
        [[Robot sharedInstance] startLog];
        [btnLog setTitle:@"Stop log" forState:UIControlStateNormal];
    }
    
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
