//
//  Robot.h
//  epuck2-ble-monitor
//
//  Created by Stefano Morgani on 01.05.19.
//  Copyright (c) 2019 GCtronic. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Constants.h"
#import "BleManager.h"


@interface Robot : NSObject {

    // Bluetooth.
    uint8_t connectionState;
    BOOL reconnectEnabled;
    NSString *robotName;
    
    // e-puck2
    BOOL logEnabled;
    NSString *logFilePath;
    uint16_t proxValues[8];
    
    // Packet reception.
    double rxTimeSeconds;
    NSDate *startTime;
    unsigned char bytePtr[MSG_SIZE_RX];
    uint8_t rxFreq;
    uint8_t rxFreqNumPackets;
    double rxTimeFreqSeconds;
    
    // Packet sending.
    uint8_t cmdToBleDev[MSG_SIZE];
    int8_t writeResponseReceived;

}

+ (id)sharedInstance;
- (void)setConnected:(BOOL)state;
- (NSString*)getRobotName;
- (void)setConnecting;
- (uint8_t)getConnectionState;
- (BOOL)isDisconnected;
- (void)setReconnectionEnabled:(BOOL)value;
- (BOOL)isReconnectionEnabled;
- (uint16_t)getProxValue:(int)index;
- (void)setMotorLeft:(int) left andRight: (int) right;
- (uint8_t)getRxFrequency;
- (void)startLog;
- (void)stopLog;
- (BOOL)isLogEnabled;

@end
